package aplicacao;

import java.io.File;
import java.io.IOException;
import java.util.Vector;
import transporte.Cliente;
import GUI.JanelaChat;


public class AplicacaoGUI {
	private String login;
	private Cliente cliente;
	private JanelaChat chat;
	
	public AplicacaoGUI() throws IOException{
		this.login = "";
		this.cliente = new Cliente(this);
	}
	
	public String getLogin(){
		return this.login;
	}
	
	public boolean conectar(String login, String senha) throws IOException{
		boolean ret = this.cliente.conectar(login, senha);
		if(ret)	this.login = login;
		return ret;
	}
	
	public Vector<Usuario> status(){
		return this.cliente.obterStatus();
	}
	
	public void desconectar() throws IOException {
		this.cliente.desconectar();
		
	}

	public void enviarMsg(String text) throws IOException {
		this.cliente.enviarMsg(this.login+" diz: "+ text+"\n");
	}
	
	public void msgRetorno(String text){
		this.chat.msgRetorno(text);
	}
	
	public void setJanelaChat(JanelaChat janela){
		this.chat = janela;
	}
	
	public void enviarArquivo(File arquivo) throws IOException{
		this.cliente.enviarArquivo(arquivo);
	}
		
}
