package confiabilidade;

import utilitario.Constantes;


public abstract class JanelaConfiabilidade {
	int base;
	int tamanho;
	Elemento janela[];
	int tamanhoMaximoDoPacote;
	
	public JanelaConfiabilidade(){//tamanho do Array
		this.tamanho = Constantes.tamanhoDoArrayDaJanela;	
		this.janela = new Elemento[tamanho];
		this.tamanhoMaximoDoPacote = Constantes.tamanhoMaximoDoPacote;
		this.inicializarJanela(this.tamanhoMaximoDoPacote);
	}		
	
	public abstract void reconhecer(int numeroSequencia);
	
	public abstract void inicializarJanela(int tamanhoDoPrimeiroPacote);
	
	protected abstract void atualizarJanela();
	
	boolean autorizou(int numeroSequencia){
		boolean retorno = false;
		if((getPosicao(numeroSequencia) >= base) && (getPosicao(numeroSequencia) <= (janela[base].getNumeroSequencia() + tamanho))){
			retorno = true;			
		}
		return retorno;
	}
	

	public Elemento[] getJanela() {
		return this.janela;
	}
	
	public int next(int posicao){
		int retorno = (posicao + 1)%this.tamanho;
		return retorno;
	}	
	
	public void setJanela(Elemento elemento) {
		if(this.getPosicao(elemento.numeroSequencia) >= 0){
			this.janela[this.getPosicao(elemento.numeroSequencia)] = elemento;
		}else{
			System.out.println("Nao existe dentro da janela pacote com numero de sequencia: " + elemento.numeroSequencia);
		}
	}
	
	protected int getPosicao(int numeroSequencia) {
		boolean achou = false;
		int retorno = -1;
		int i = 0;
		while(i < this.tamanho && !achou){
			if(this.janela[i].numeroSequencia == numeroSequencia){
				achou = true;
				retorno = i;
			}
			i++;
		}
		return retorno;
	}

	public int getTamanho(){
		return this.tamanho;
	}

	//retorna o numero de sequencia da base
	public int getBase() {
		return this.janela[base].getNumeroSequencia();
	}

	public void setJanela(Elemento[] janela) {
		this.janela = janela;
	}
		
}
