package confiabilidade;

import java.util.Vector;

import utilitario.Condicoes;



public class JanelaDestinatario extends JanelaConfiabilidade{
	Vector<Integer> numerosSequenciaEmOrdem;
	int numSeqEsperado;
	public JanelaDestinatario() {
		super();
		numerosSequenciaEmOrdem = new Vector<Integer>();
		this.numSeqEsperado = 0;
	}	
	
	public void inicializarJanela(int tamanhoDoPrimeiroPacote){
		int numeroSequencia = 0;
		for(int i = 0; i < this.tamanho; i++){
			this.janela[i] = new Elemento(Condicoes.Aceitavel, numeroSequencia);
			numeroSequencia = numeroSequencia + tamanhoDoPrimeiroPacote;
		}
	}

	public void reconhecer(int numeroSequencia){
		if(this.janela[this.base].numeroSequencia == numeroSequencia){
			this.atualizarJanela();
			while(this.janela[this.base].condicoes == Condicoes.ForaDeOrdemReconhecido){
				this.atualizarJanela();
			}
		}else{
			this.setJanela(new Elemento(Condicoes.ForaDeOrdemReconhecido, numeroSequencia));
			for(int i = this.getPosicao(numeroSequencia) - 1; i >= this.base ; i--){
				if(this.janela[i].condicoes == Condicoes.Aceitavel){
					this.janela[i].condicoes = Condicoes.AguardadoNaoRecebdo;
				}
			}
		}
	}

	protected void atualizarJanela(){
		//colocar em uma estrutura de dados os numeros de sequencia liberados
		System.out.println("atualizooooooooooooooooooou" + this.janela[this.base].getNumeroSequencia());
		numerosSequenciaEmOrdem.add(this.janela[this.base].numeroSequencia);
		this.numSeqEsperado = this.janela[this.base].numeroSequencia;
		this.base = next(this.base);
		int ultimo = ((this.base + this.tamanho) - 1)%this.tamanho;
		int penultimo = 0;
		penultimo  = (ultimo - 1)%this.tamanho;
		if(penultimo == -1) penultimo = this.tamanho - 1;
		
		this.janela[ultimo].numeroSequencia = this.janela[penultimo].numeroSequencia + tamanhoMaximoDoPacote;
		this.janela[ultimo].condicoes = Condicoes.Aceitavel;
	}
	
	/**
	 * Retorna os numeros de sequencia dos pacotes que jah estao em ordem e podem ser removidos do buffer de recepcao.
	 * */
	public Vector<Integer> getNumerosSequenciaEmOrdem(){
		return this.numerosSequenciaEmOrdem;
	}
	

	public int getNumSeqEsperado() {//alteracao : metodo inserido		
		return this.numSeqEsperado;
	}
	
}
