package transporteTCP;

import java.io.*;
import java.net.*;
import java.util.Vector;
import transporte.Cliente;
import aplicacao.Usuario;

public class ClienteTCP{
	private Vector<Socket> socketCliente;
	private Vector<DataOutputStream> toServidorClientes;
	private Cliente cliente;
	
	public ClienteTCP(Cliente cliente){
		this.toServidorClientes = new Vector<DataOutputStream>();
		this.socketCliente = new Vector<Socket>();
		this.cliente = cliente;
	}
	
	public void conectarUsuario(Usuario novoUsuario) throws UnknownHostException, IOException{
		this.socketCliente.add(new Socket(novoUsuario.getIP(),2009));
		int tam = this.socketCliente.size();
		this.toServidorClientes.add(new DataOutputStream(this.socketCliente.get(tam-1).getOutputStream()));
		this.toServidorClientes.get(tam-1).writeBytes("dono\n");
		this.toServidorClientes.get(tam-1).writeBytes(this.cliente.getLogin()+"\n");
	}
	
	public void desconectarUsuario(Usuario usuarioVelho){
		boolean removido = false;
		int index = 0;
		while(index < this.socketCliente.size() && !removido){
			if(this.socketCliente.get(index).getInetAddress().toString().substring(1).equalsIgnoreCase(usuarioVelho.getIP())){
				this.socketCliente.remove(index);
				this.toServidorClientes.remove(index);
				removido = true;
			}else{
				index++;
			}
		}
	}
	
	public void enviarMsg(String texto) throws IOException{
		for(int i = 0; i < this.toServidorClientes.size(); i++){
			this.toServidorClientes.get(i).writeBytes(texto);
		}
	}
	
	public void desconectar() throws IOException{
		for(int index = 0; index < this.socketCliente.size();index++){
			this.socketCliente.get(index).close();
			this.toServidorClientes.get(index).close();
		}
		this.socketCliente.removeAllElements();
		this.toServidorClientes.removeAllElements();
	}
	

}
