package transporteTCP;

import java.io.IOException;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Vector;
import transporte.Cliente;
import aplicacao.Usuario;

public class ServidorTCP extends Thread{
	Vector<ThreadCliente> clientes; 
	private Cliente cliente;
	ServerSocket servidor;
	private boolean conectado;
	
	public ServidorTCP(Cliente cliente) throws IOException{
		this.servidor = new ServerSocket(2009);
		this.cliente = cliente;
		this.clientes = new Vector<ThreadCliente>();
		this.conectado = true;
		
	}
	
	public void run(){
		while(this.cliente.getConectado() && this.conectado){
				try {
					Socket novoCliente = this.servidor.accept();
					this.clientes.add(new ThreadCliente(novoCliente,this));
					int tam = this.clientes.size();
					this.clientes.get(tam -1).start();
				} catch (IOException e) {
					//e.printStackTrace();
					this.conectado = false;
				}
		}
	} 
	
	
/*	public void conectarUsuario(Usuario novoUsuario) throws IOException{
		//Socket novoCliente = this.servidor.accept();
		while(!this.requisicaoDeConexao){
		}
		this.clientes.add(new ThreadCliente(this.clienteConexao,this,novoUsuario));
		int tam = this.clientes.size();
		this.clientes.get(tam -1).start();
		this.requisicaoDeConexao = false;
	}*/
	
	public void desconectarUsuario(Usuario usuarioVelho){
		boolean achou = false;
		int index = 0;
		while(index < this.clientes.size() && !achou){
			if(usuarioVelho.getLogin().equalsIgnoreCase(this.clientes.get(index).getDono())){
				this.clientes.get(index).setConectado(false);
				this.clientes.remove(index);
				achou = true;
			}else{
				index++;
			}
		}
	}
	
	public void desconectar() throws IOException{
		this.clientes.removeAllElements();
		this.servidor.close();
	}

	synchronized public boolean getConectado() {
		return this.cliente.getConectado();
	}

	synchronized public void msgServidor(String readLine) {
		this.cliente.receberMsg(readLine);
	}

	public void receberMsgAck(Vector<String> msg) {
		this.cliente.receberMsgAck(msg);
	}

	public void nomeArquivo(String string, InetAddress ip) throws IOException {
		this.cliente.nomeArquivo(string,ip);
	}
}
