package transporteTCP;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.Socket;
import java.util.Vector;

public class ThreadCliente extends Thread{
	private String dono;
	private Socket cliente;
	private BufferedReader fromServidorClientes;
	private ServidorTCP servidor;
	private boolean conectado;
	
	public ThreadCliente(Socket novoCliente, ServidorTCP servidor) throws IOException {
		// TODO Auto-generated constructor stub
		this.dono = "";
		this.cliente = novoCliente;
		this.servidor = servidor;
		this.fromServidorClientes = new BufferedReader(new InputStreamReader(this.cliente.getInputStream()));
		this.conectado = true;
	}

	public void run(){
		while(this.servidor.getConectado() && this.conectado){
			//RECEBENDO MSG DOS OUTROS CLIENTES
			try {
				String msg = this.fromServidorClientes.readLine();
				if(msg != null){
					if(msg.equalsIgnoreCase("dono")){
						this.dono = this.fromServidorClientes.readLine();
					}else if(msg.equalsIgnoreCase("ACK")){
						Vector<String> retAck = new Vector<String>();
						retAck.add(this.dono); 
						retAck.add(this.fromServidorClientes.readLine());
						retAck.add(this.fromServidorClientes.readLine());
						this.receberMsgAck(retAck);
					}else if(msg.equalsIgnoreCase("enviarArquivo")){
						this.receberNomeArquivo(this.fromServidorClientes.readLine());
					}else{
						this.enviarMsg(msg);						
					}
				}
			} catch (IOException e) {
				this.enviarMsg(this.dono + " desconectou!");
				this.conectado = false;
			}
		}
		//FECHANDO A CONEXAO DO SOCKET COM O SERVIDOR 
		try {
			this.cliente.close();
			this.fromServidorClientes.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private void receberNomeArquivo(String string) throws IOException {
		this.servidor.nomeArquivo(string, this.cliente.getInetAddress());
	}

	public void setConectado(boolean status){
		this.conectado = status;
	}
	
	public void enviarMsg(String readLine) {
		this.servidor.msgServidor(readLine);
	}
	
	public void receberMsgAck(Vector<String> msg){
		this.servidor.receberMsgAck(msg);
	}
	
	public String getDono(){
		return this.dono;
	}
}
