	package transporteUDP;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.util.Vector;

import aplicacao.Usuario;

import transporte.Cliente;
import utilitario.Pacote;
import utilitario.Remontador;


public class ServidorUDP {
	Vector<Recepcao> recepcao;
	Remontador remontador;
	ConexaoServidorUDP conexaoServidorUDP;
	Cliente cliente;
	private boolean chegouPacote;
	private byte[] pck;
	private int portaCliente;
	private InetAddress ipCliente;
	
	public ServidorUDP(Cliente cliente) throws IOException{
		this.cliente = cliente;
		this.recepcao = new Vector<Recepcao>();
		this.remontador = new Remontador();
		this.conexaoServidorUDP = new ConexaoServidorUDP(this);
		this.conexaoServidorUDP.start();
		
	}

	synchronized public void receberArquivo(Pacote[] pacotesDoBuffer, FileOutputStream stream) {
		//falta definir o numero e tamanho das partes
			try {
				this.remontador.setSaida(this.remontador.remontarArquivo(pacotesDoBuffer), stream);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	}

	public void enviarMsg(String string) throws IOException {
		this.cliente.enviarMsg(string);
	}

	public void setAdicionado(boolean status) {
		this.chegouPacote = status;
	}
	public boolean getAdicionado(){
		return this.chegouPacote;
	}

	public void setPck(byte[] pacote) {
		this.pck = pacote;
	}

	public byte[] getPacote() {
		return this.pck;
	}

	public void setIpCliente(InetAddress ip) {
		this.ipCliente = ip;
	}

	public void setPortaCliente(int port) {
		this.portaCliente = port;
	}

	public InetAddress getIpCliente() {
		return this.ipCliente;
	}

	public int getPortaCliente() {
		return this.portaCliente;
	}

	public void pckRecebido(byte[] pacoteEmBytes) {
		this.setPck(pacoteEmBytes);
		int index = 0;
		boolean igual = false;
		while(index < this.recepcao.size() && !igual){
			if(this.ipCliente.equals(this.recepcao.get(index).getIp()) && this.portaCliente == this.recepcao.get(index).getPorta()){
				igual = true;
			}else{
				index++;
			}
		}
		if(!igual){
			this.recepcao.add(new Recepcao(this,this.ipCliente,this.portaCliente));
			this.recepcao.lastElement().start();
		}
	}

	public boolean getConectado() {
		return this.cliente.getConectado();
	}

	public void desconectarUsuario(Usuario novoUsuario) {
		int index = 0;
		boolean achou = false;
		while(index < this.recepcao.size() && !achou){
			if(this.recepcao.get(index).getIp().toString().substring(1).equalsIgnoreCase(novoUsuario.getIP())){
				this.recepcao.get(index).setConectado(false);
				this.recepcao.remove(index);
				achou = true;
			}else{
				index++;
			}
		}
	}

	public void nomeArquivo(String string, InetAddress ip) throws IOException {
		int index = 0;
		boolean achou = false;
		while(index < this.recepcao.size() && !achou){
			if(this.recepcao.get(index).getIp().equals(ip)){
				this.recepcao.get(index).setStream(string);
			}else{
				index++;
			}
		}
	}
	
	
}
