package utilitario;


public class BufferRecepcao {
	private final int tamanhoBuffer = 64000;
	private int indexBuffer;
	private byte byteBuffer[];

	
	public BufferRecepcao() {
		this.byteBuffer =  new byte[this.tamanhoBuffer];
		this.indexBuffer = 0;
	}
	
	
	public int setDadosBuffer(byte[] dados) {
		int retorno = 0;
		if((dados.length + this.indexBuffer) <= this.tamanhoBuffer) {
			for(int i = 0; i < dados.length; i++) {
				this.byteBuffer[i + this.indexBuffer] = dados[i];
			}
			
			this.indexBuffer = this.indexBuffer + dados.length;
			
		}else{
			System.out.println("Buffer no suporta esse tamanho!");
			retorno = -1;
		}
			
		return retorno;
	}
	
	
	public byte[] getDadosBuffer(int numeroBytes) {
		byte[] retorno = new byte[numeroBytes];
		
		for(int i = 0; i < numeroBytes; i++) {
			retorno[i] = this.byteBuffer[i];
		}
		
		this.removerDados(numeroBytes);
		
		return retorno;
	}
	
	public void removerDados(int numeroBytes) {
		for(int i = numeroBytes; i < this.tamanhoBuffer; i++) {
			this.byteBuffer[i - numeroBytes] = this.byteBuffer[i];
		}
		
		//no  necessrio
		
		for(int j = this.tamanhoBuffer - numeroBytes; j < this.tamanhoBuffer; j++ ) {
			this.byteBuffer[j] = 0;
		}
		
		this.indexBuffer = this.indexBuffer - numeroBytes;
	}
	
	public int getTamanhoRestante() {
		return (this.tamanhoBuffer - this.indexBuffer);
	}
	
	public int getQuantidadePacotes() {
		return (this.indexBuffer/1020);
	}
	
	public void imprimirBuffer() {
		System.out.println("buffer");
		for(int i = 0; i < this.indexBuffer; i++) {
			System.out.println(this.byteBuffer[i]);
		}
	}
	
	
	
	
	public static void main(String[] args) {
		BufferRecepcao b = new BufferRecepcao();
		byte[] array1 = {1,2,3,4,5,6};
		byte[] array2 = {7,8,9,10};
		byte[] array3 = {11,12};
		byte[] array4 = {13,14,15};
		byte[] arrayEstouro = new byte[64000];
		
		b.setDadosBuffer(array1);
		b.setDadosBuffer(array2);
		System.out.println("Tamanho Restante = "+b.getTamanhoRestante());
		b.removerDados(10);
		b.setDadosBuffer(array3);
		b.removerDados(1);
		System.out.println("Tamanho Restante = "+b.getTamanhoRestante());
		b.setDadosBuffer(array4);
		
		b.setDadosBuffer(arrayEstouro);
		
		b.imprimirBuffer();
		
		System.out.println("Tamanho Restante = "+b.getTamanhoRestante());
		
		
		
	}
}
