package utilitario;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;


public class Segmentador {
	

	public Pacote[] segmentarArquivo(File file, int tamanhoCabecalho, int tamanhoPacote,int parte) throws IOException {
		Pacote[] pacotes;
		
		byte[] dadosUltimoPacote;
		byte[] dadosArqSegmentado;
		byte[] dadosArq = this.getDadosDividido(file,parte);
		
		long tamanhoArquivo = dadosArq.length;	

		//tamanhoPacote - tamanhoCabecalho = 1000 (VER SE PRECISA DISSO!)
		int numeroPacotes = (int)Math.ceil((double) tamanhoArquivo / (tamanhoPacote - tamanhoCabecalho));		
		
		int tamanhoUtil = (tamanhoPacote - tamanhoCabecalho);
		int k = 0;
		
		byte flag;
		int numSeq;
		short checksum;
		
		pacotes = new Pacote[numeroPacotes];
		for(int i = 0; i < numeroPacotes - 1; i++) {
			dadosArqSegmentado = new byte[tamanhoUtil];

			for(int j = 0; j < tamanhoUtil; j++) {
				dadosArqSegmentado[j] = dadosArq[k];
				k++;
			}
					
			flag = 1;
			numSeq = i*tamanhoUtil;
			checksum = 0;
			
			pacotes[i] = new Pacote(flag,numSeq,checksum,dadosArqSegmentado);	
		}
		
		//Ultimo Elemento (Tamanho Varivel)
		
		int tamanhoUltimoPacote = (int) (tamanhoArquivo - ((numeroPacotes - 1) * (tamanhoPacote - tamanhoCabecalho)));
		
		
		dadosUltimoPacote = new byte[(int) tamanhoUltimoPacote];
		
		for(int l = 0; l < tamanhoUltimoPacote; l++) {
			dadosUltimoPacote[l]  = dadosArq[k];
			k++;
		}
		
				
		flag = 0;
		numSeq = ((numeroPacotes - 1)*tamanhoUtil);
		checksum = 0;
		
		pacotes[(int) (numeroPacotes - 1)] = new Pacote(flag,numSeq,checksum,dadosUltimoPacote);		
		
		return pacotes;
	}
	
	public int numeroDivisaoPacote(File file) {
		long tamanhoArq = file.length();
		int tamanhoMax = 4000000;
		
		return (int) ( Math.ceil((double) tamanhoArq/tamanhoMax));	
	}
	
	//Depois apagar, apenas para teste
	byte[] getDados(File file) throws IOException {
		
		InputStream is = new FileInputStream(file);
	    
        // Get the size of the file
        long length = file.length();

        // Create the byte array to hold the data
        byte[] bytes = new byte[(int)length];
    
        // Read in the bytes
        int offset = 0;
        int numRead = 0;
        while (offset < bytes.length
               && (numRead = is.read(bytes, offset, bytes.length-offset)) >= 0) {
            offset += numRead;
        }
    
        // Ensure all the bytes have been read in
        if (offset < bytes.length) {
            throw new IOException("Could not completely read file "+file.getName());
        }
    
        // Close the input stream and return bytes
        is.close();
        return bytes;
    }

	
	
	byte[] getDadosDividido(File file, int parte) throws IOException {		
		
		InputStream is = new FileInputStream(file);
		int numeroDeDivisoes = numeroDivisaoPacote(file);
		long length;
	    
				
        // Get the size of the file
        if(numeroDeDivisoes == 1) {
        	length = file.length();
        } else if(numeroDeDivisoes == parte) {
        	length = file.length() - (parte-1)*4000000;
        	is.skip((parte-1)*4000000);
        } else {
        	length = 4000000;
        	is.skip((parte-1)*4000000);
        }
		
        // Create the byte array to hold the data
        byte[] bytes = new byte[(int)length];
        
    
        // Read in the bytes
        int offset = 0;
        int numRead = 0;
        
        
        while (offset < bytes.length
                && (numRead = is.read(bytes, offset, bytes.length-offset)) >= 0) {
             offset += numRead;

         }
        
        if (offset < bytes.length) {
            throw new IOException("Could not completely read file "+file.getName());
        }
        
        // Close the input stream and return bytes
        is.close();
        return bytes;
    }
	
	
	
	


	
	
	
	public static void main(String[] args) throws IOException {	
	
		File testeEntrada = new File("C:\\Documents and Settings\\mcbb\\Desktop\\estatistica0001.pdf");
		//File testeSaida = new File("C:\\Documents and Settings\\lgr2\\Desktop\\tex_saida.pdf");
		Segmentador segmentadorDividido = new Segmentador();
		byte[] array = segmentadorDividido.getDados(testeEntrada);
		
		for(int i = 0; i < 1000; i++ ){
			System.out.println("Byte["+i+"]="+array[i]);
		}
		
		
	
	}
	
}




