package utilitario;


public class Temporizador extends Thread {

	protected int rate_msec = 100;
	
	private int lenght_msec;
	
	private int elapsed_msec;
	
	private boolean ack;
	
	private boolean timeout;
	
	public Temporizador(int lenght) {
		this.lenght_msec = lenght;
		this.elapsed_msec = 0;
		this.timeout = false;
		this.ack = false;
	}

	public void run() {
		while(!this.ack && !this.timeout) {
			try {
				Thread.sleep(rate_msec);
			} catch (InterruptedException e) {
				//continue;
				synchronized(this) {
					this.elapsed_msec += this.rate_msec;
					if(this.elapsed_msec > this.lenght_msec) {
						this.timeout = true;
					}
				}
			}
		}
	}

	public int getLenght_msec() {
		return lenght_msec;
	}

	public void setLenght_msec(int lenght_msec) {
		this.lenght_msec = lenght_msec;
	}

	public int getElapsed_msec() {
		return elapsed_msec;
	}

	public void setElapsed_msec(int elapsed_msec) {
		this.elapsed_msec = elapsed_msec;
	}

	public boolean isAck() {
		return ack;
	}
	/**
	 * Esse metodo deve ser chamado quando o ack correspondente do pacote UDP
	 * que ativou o temporizador for reconhecido.
	 * Ao chamar este metodo, o transmissor do pacote desliga seu respectivo
	 * temporizador
	 * @param ack
	 */
	public synchronized void setAck(boolean ack) {
		this.ack = ack;
	}
	
	public synchronized boolean isTimeout() {
		return timeout;
	}
	
	public boolean getTimeOut(){
		return this.timeout;
	}
	
	public void setTimeOut(boolean status){
		this.timeout = status;
	}

}
