import java.io.File;
import java.io.FileNotFoundException;
import java.net.SocketAddress;
import java.util.Scanner;
import java.util.Vector;

public class Servico {

	Scanner registro;
	Vector<Usuario> usuarios;
	
	public Servico(){		
		this.usuarios = new Vector<Usuario>();		
		try {
			this.registro = new Scanner(new File("usuarios.txt"));
		} catch (FileNotFoundException e) {
			//e.printStackTrace(;
			System.out.println("Arquivo nao encontrado");
		}
		this.criarUsuarios();
	} 
	
	synchronized void setStatus(String on_off_line, String login){
		int posicao = getPosicao(login);
		usuarios.get(posicao).setOnline(true);
	}
	
	synchronized Vector<Usuario> contatosOnLine(){//chamado pelo cliente
		Vector<Usuario> contatosOnline = new Vector<Usuario>();
		for(int a = 0; a < this.usuarios.size(); a++){
			if(this.usuarios.get(a).isOnline()){
				contatosOnline.add(usuarios.get(a));
			}
		}
		return contatosOnline;
	}

	
	synchronized Vector<String> atualizarStatus(){//chamado dentro do loop infinito do servidor
		Vector<String> retorno = null;
		//utiliza setStatus
		//manda a lista de logins online
		return retorno;
	}
	
	synchronized boolean verificarSenha(String login, String senha) throws UsuarioNaoEncontradoException, SenhaIncorretaException{
		boolean retorno = false;
		
		if(getPosicao(login) != -1){				
			if(senha.equals(buscarSenha(login))){
				retorno = true;				
			}else{
				throw new SenhaIncorretaException("Senha invalida\n");
			}
		}else{
			retorno = false;
			throw new UsuarioNaoEncontradoException("Usuario nao encontrado\n");
		}
		return retorno;
	}
	
	synchronized int getPosicao(String login){
		int retorno = -1;
		int tam = usuarios.size();
		boolean achou = false;
		for(int i = 0; i < tam && !achou; i++){
			if(login.equals(usuarios.get(i).getLogin())){				
				retorno = i;
				achou = true;
			}
		}
		return retorno;
	}
	
	synchronized String buscarSenha(String login){
		try {
			registro = new Scanner(new File("usuarios.txt"));
		} catch (FileNotFoundException e) {
			//e.printStackTrace();
			System.out.println("Arquivo nao encontrado");
		}
		String retorno = null;
		boolean achou = false;
		while(registro.hasNext() && !achou){
			String loginRegistro = registro.nextLine();
			if(!loginRegistro.equals("-1")){								
				if(loginRegistro.equals(login)){
					retorno =  registro.nextLine();//pulando a senha
					achou = true;
				}else{
					registro.nextLine();//pulando a senha
				}
				registro.nextLine();//pulando o espaco
			}
		}
		registro.close();
		return retorno;
	}
			
	synchronized void criarUsuarios(){		
		while(registro.hasNext()){
			String login = registro.nextLine();
			if(!login.equals("-1")){
				registro.nextLine();
				registro.nextLine();
				this.usuarios.add(new Usuario(login));
			}
		}
		registro.close();
		//le o arquivo e instancia os usuarios, lendo do arquivo os logins existentes
		//lendo os logins e colocando os usuarios no Vector		
	}
	
	synchronized boolean conectar(String login, String senha, String IP, int porta, SocketAddress endPoint) throws UsuarioNaoEncontradoException, SenhaIncorretaException{
		boolean retorno = false;
		int posicao = getPosicao(login);
		
		if(verificarSenha(login, senha)){
			usuarios.get(posicao).setIP(IP);
			usuarios.get(posicao).setPorta(porta);
			usuarios.get(posicao).setOnline(true);
			usuarios.get(posicao).setAddress(endPoint);
			retorno = true;
		}
		return retorno;
	}
	

	synchronized void desconectar(String login){	
		int posicaoAtual = this.getPosicao(login);			
		if(posicaoAtual != -1){
			this.usuarios.get(posicaoAtual).setOnline(false);
		}		
	}
	
	/*public static void main(String args[]){
		Servico servico = new Servico();
		int i = 0;
		int tam = servico.usuarios.size();
		System.out.println("tamanho: " + tam);
		while(i < tam){
			System.out.println(servico.usuarios.get(i).getLogin());
			i++;
		}
		
		System.out.println("Lauro:" + servico.buscarSenha("Lauro"));
		System.out.println("Maria:" + servico.buscarSenha("Maria"));
		System.out.println("Leo:" + servico.buscarSenha("Leo"));
		System.out.println("Fbio:" + servico.buscarSenha("Fbio"));
		System.out.println("Maryane:" + servico.buscarSenha("Maryane"));
		System.out.println("Artur:" + servico.buscarSenha("Artur"));
		
		System.out.println("true = " + servico.verificarSenha("Leo", "ehOseguinte"));
		System.out.println("true = " + servico.verificarSenha("Maria", "040389"));
		System.out.println("true = " + servico.verificarSenha("Artur", "panda"));
		System.out.println("true = " + servico.verificarSenha("Lauro", "caraiVei"));
		System.out.println("true = " + servico.verificarSenha("Fbio", "donzelo"));
		System.out.println("true = " + servico.verificarSenha("Maryane", "linda"));
		
		System.out.println("false = " + servico.verificarSenha("Leo", "ehOseghngjcuinte"));
		System.out.println("false = " + servico.verificarSenha("Maria", "fh"));
		System.out.println("false = " + servico.verificarSenha("Artur", "fhfh"));
		System.out.println("false = " + servico.verificarSenha("Lauro", "7956"));
		System.out.println("false = " + servico.verificarSenha("Fbio", "2732"));
		System.out.println("false = " + servico.verificarSenha("Maryane", "zx "));
		
		servico.conectar("Maryane", "linda", "1.1.1.1", 80);
		servico.conectar("Fbio", "donzelo", "1.1.1.1", 80);
		servico.conectar("Leo", "ehOseguinte", "1.1.1.1", 80);
		System.out.println("Conectou maryane, fabio e leo");
		
		tam = servico.contatosOnLine().size();
		i = 0;
		while(i < tam){
			System.out.println(servico.contatosOnLine().get(i).getLogin());
			i++;
		}
		servico.desconectar("Maryane");
		System.out.println("desconectou Maryane:\n");
		tam = servico.contatosOnLine().size();
		i = 0;
		while(i < tam){
			System.out.println(servico.contatosOnLine().get(i).getLogin());
			i++;
		}
	}*/
}
