import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;


public class ThreadCliente extends Thread {

	Servico servico;
	String loginFromClient; 
	String senhaFromClient;
	String outToClient;
	String operacao;
	Socket sock;
	private boolean desconectou;
	
	public ThreadCliente (Socket sock, Servico servico, String outToClient) {
		
		this.servico = servico;
		this.outToClient = outToClient;
		this.sock = sock;
		this.desconectou = false;
	}

	public void run() {
		while(!desconectou){
			//socket de conexo TCP
			try{							
			
				//buffer de entrada, que recebe um stream
				BufferedReader socketIn = new BufferedReader(new InputStreamReader(sock.getInputStream()));
				//stream de saida
				DataOutputStream socketOut = new DataOutputStream(sock.getOutputStream());
				
				operacao = socketIn.readLine();
				if(operacao.equalsIgnoreCase("conectar")){
					//---------------------Cliente requisitando conexao
					System.out.println("Servidor| Cliente requisitando conexao");
					loginFromClient = socketIn.readLine();			
					senhaFromClient = socketIn.readLine();
					
					System.out.println("Servidor| conexo requisitada:" + loginFromClient);
					System.out.println("Servidor| IP do cliente: " + sock.getInetAddress());
					System.out.println("Servidor| Porta no cliente: " + sock.getPort());
					System.out.println("Servidor| Porta local: " + sock.getLocalPort());
					
					try{
						boolean funcionou = servico.conectar(loginFromClient, senhaFromClient, sock.getInetAddress().toString(), sock.getPort(),sock.getLocalSocketAddress());
						if(funcionou){
							socketOut.writeBytes("conectado\n");							
						}
					}catch(UsuarioNaoEncontradoException e){
						socketOut.writeBytes(e.getMessage());
					}catch(SenhaIncorretaException e){
						socketOut.writeBytes(e.getMessage());
					}
				}else if(operacao.equalsIgnoreCase("status")){
			
					//--------------Cliente requisitando lista de contatos on-line
					//System.out.println("Servidor| Cliente requisitando lista de contatos on-line");
					int tam = servico.contatosOnLine().size();
					int i = 0;	
					
					outToClient = tam + "\n";
		
					while(i < tam){				
						outToClient = outToClient + servico.contatosOnLine().get(i).getLogin() + "\n" ;
						outToClient = outToClient + servico.contatosOnLine().get(i).getIP() + "\n" ;
						outToClient = outToClient + servico.contatosOnLine().get(i).getPorta() + "\n" ;
						i++;
					}
					
					//--------------------------
				
				//escrevendo no socket]
				
				socketOut.writeBytes(outToClient);
				
				}else{//Desconectar
					loginFromClient = socketIn.readLine();
					System.out.println("Servidor | Cliente " + loginFromClient + " requisitando desconexo.");
					servico.desconectar(loginFromClient);
					socketOut.writeBytes("desconectado\n");
					this.sock.close();
					this.desconectou = true;
				}
			
			}catch(IOException e){
				System.out.println("Class ThreadCliente: cliente caiu!" );
				System.out.println("Class ThreadCliente: " + e.getMessage() + "Falta tratar a queda do cliente, timeout, etc...");
				this.servico.desconectar(this.loginFromClient);
				this.desconectou = true;
			}
			
		}
	}
	
}
